﻿using System;

namespace ApiCorpExample
{
    class Program
    {
        static void Help()
        {
            Console.WriteLine("Usage of ApiCorpExample.exe:");
            Console.WriteLine("ApiCorpExample.exe /pdf <filename>");
            Console.WriteLine("ApiCorpExample.exe /tariff");
            Console.WriteLine("ApiCorpExample.exe /folders <filename1> <filename2>");
            Console.WriteLine("ApiCorpExample.exe /storage <filename1> <filename2>");
            Console.WriteLine("ApiCorpExample.exe /simple <filename>");
            Console.WriteLine("ApiCorpExample.exe /web <filename>");
            Console.WriteLine("ApiCorpExample.exe /uploaded");
            Console.WriteLine("ApiCorpExample.exe /checked");
            Console.WriteLine("ApiCorpExample.exe /indexed");
            Console.WriteLine("ApiCorpExample.exe /exception <filename>");
            Console.WriteLine("ApiCorpExample.exe /verReport <filename>");
            Console.WriteLine("ApiCorpExample.exe /selfcite <filename>");
        }

        static void Main(string[] args)
		{
			if (args.Length < 1) { Help(); return; }

            switch (args[0])
            {
                case "/pdf":
                    ExamplesNative.ExportReportToPdf(args[1]);
                    break;
                case "/tariff":
                    ExamplesNative.GetTariffInfo();
                    break;
                case "/folders":
                    if (args.Length < 3) { Help(); return; }
                    ExamplesNative.FoldersMethods(args[1], args[2]);
                    break;
                case "/storage":
                    if (args.Length < 3) { Help(); return; }
                    ExamplesNative.StorageMethods(args[1], args[2]);
                    break;
                case "/simple":
                    if (args.Length < 2) { Help(); return; }
                    ExamplesNative.SimpleCheck(args[1]);
                    break;
                case "/web":
                    if (args.Length < 2) { Help(); return; }
                    ExamplesNative.GetWebReport(args[1]);
                    break;
                case "/uploaded":
                    ExamplesNative.EnumerateDocuments();
                    break;
                case "/checked":
                    ExamplesNative.EnumerateReports();
                    break;
                case "/indexed":
                    ExamplesNative.EnumerateIndex();
                    break;
                case "/exception":
                    if (args.Length < 2) { Help(); return; }
                    ExamplesNative.IncorrectUpload(args[1]);
                    break;
                case "/verReport":
                    if (args.Length < 2) { Help(); return; }
                    ExamplesNative.GetVerificationReport(args[1]);
                    break;
                case "/selfcite":
                    if (args.Length < 2) { Help(); return; }
                    ExamplesNative.SelfCiteCheck(args[1]);
                    break;
                default:
                    Console.WriteLine("Command <{0}> is unknown", args[0]);
                    Help();
                    break;
            }
        }
    }
}
