<?php
//
// N.B. Включить openssl и soap в php.ini!
//
$ANTIPLAGIAT_URI = 'https://testapi.antiplagiat.ru';


// Создать клиента сервиса(https)
$LOGIN = "testapi@antiplagiat.ru";
$PASSWORD = "testapi";
$COMPANY_NAME = 'testapi';
$APICORP_ADDRESS = 'api.antiplagiat.ru:44902';

$oldValue = libxml_disable_entity_loader( false );
$client = new SoapClient("https://$APICORP_ADDRESS/apiCorp/$COMPANY_NAME?singleWsdl",
                         array("trace"=>1,
                               "login"=>$LOGIN,
                               "password"=>$PASSWORD,
                               "soap_version" => SOAP_1_1,
                               "features" => SOAP_SINGLE_ELEMENT_ARRAYS,
                        ));
libxml_disable_entity_loader( $oldValue );


function soap_debug($client){
    $requestHeaders = $client->__getLastRequestHeaders();
    $request = $client->__getLastRequest();
    $responseHeaders = $client->__getLastResponseHeaders();
    $response = $client->__getLastResponse();

    // print("requestheaders:");
    // print($requestHeaders);
    // print("request:");
    // print($request);
    // print("responseHeaders:");
    // print($responseHeaders);
    // print("response:");
    // print($response);
}

// Подготовка описания загружаемого файла.
function get_doc_data($filepath) {
    return array (
        "Data" => file_get_contents($filepath),
        "FileName" => basename($filepath),
        "FileType" => "." . substr(strrchr($filepath, "."), 1),
        "ExternalUserID" => "ivanov" // поле надо заполнять идентификатором реального пользователя во внешней системе;
    );
}

// Пример самого распространенного сценария проверки документа.
function simple_check($filepath) {
    global $client;
    global $COMPANY_NAME;
    // Описание загружаемого файла
    $data = get_doc_data($filepath);
	$attributes = array(
		"DocumentDescription" => array(
			"Authors" => array (
				"AuthorName" => array (
					"OtherNames" => "Иван Иванович",
					"Surname" => "Иванов",
					"PersonIDs" => array(
						"CustomID" => "original"
					)
				)

			)
		)
	);
    // Загрузка файла
    $uploadResult = $client->UploadDocument(array("data"=>$data, "attributes"=>$attributes));

    // Идентификатор документа. Если загружается не архив, то список загруженных документов будет состоять из одного элемента.
    $id = $uploadResult->UploadDocumentResult->Uploaded[0]->Id;

	// Отправить на проверку с использованием всех подключеных компании модулей поиска
    $client->CheckDocument(array("docId" => $id));
	// Отправить на проверку с использованием только собственного модуля поиска и модуля поиска "wikipedia". Для получения списка модулей поиска см. пример get_tariff_info()
    // $client->CheckDocument(array("docId" => $id, "checkServicesList" => array($COMPANY_NAME, "wikipedia")));

    // Получить текущий статус последней проверки
    $status = $client->GetCheckStatus(array("docId" => $id));

    // Цикл ожидания окончания проверки
    while ($status->GetCheckStatusResult->Status === "InProgress")
    {
        sleep($status->GetCheckStatusResult->EstimatedWaitTime * 0.1);
        $status = $client->GetCheckStatus(array("docId" => $id));
    }

    // Проверка закончилась не удачно.
    if ($status->GetCheckStatusResult->Status === "Failed")
    {
        echo("При проверке документа произошла ошибка:" + $status->GetCheckStatusResult->FailDetails);
        return;
    }

    // Получить краткий отчет
    $report = $client->GetReportView(array("docId" => $id));

    foreach ($report->GetReportViewResult->CheckServiceResults as $checkService) {
        // Информация по каждому поисковому модулю
        echo("Check service: $checkService->CheckServiceName Score.White=" .
             $checkService->ScoreByReport->Legal . "% Score.Black=" .
             $checkService->ScoreByReport->Plagiarism . "% Score.SelfCite=" .
             $checkService->ScoreByReport->SelfCite . "%\n");
        if (isset($checkService->Sources)) {
            foreach($checkService->Sources as $source) {
                // Информация по каждому найденному источнику
                echo("\t" . $source->SrcHash .": Score=" . $source->ScoreByReport . "% (".
                     $source->ScoreBySource . "%), Name='".$source->Name."' ".
                     "Author='".$source->Author."' " .
                     "Url='".$source->Url."'\n");
            }
        }
    }

    // Получить полный отчет
    $fullReport = $client->GetReportView(array("docId" => $id, "options" => array("FullReport" => true, "NeedText" => true, "NeedStats" => true, "NeedAttributes" => true)));

    if (isset($fullReport->GetReportViewResult->Details->CiteBlocks)) {
        // Найти самый большой блок заимствований и вывести его

        $maxlen = max(array_map(function($c) { return $c->Length; }, $fullReport->GetReportViewResult->Details->CiteBlocks));

        foreach ($fullReport->GetReportViewResult->Details->CiteBlocks as $block)
            if ($block->Length === $maxlen)
                echo("Max block length=".$block->Length." Source=".
                      $block->SrcHash." text:\n".
                      ($fullReport->GetReportViewResult->Details->Text.substr($block->Offset, min($block->Length, 200)))."...\n");
    }
	echo("Author Surname = ".$fullReport->GetReportViewResult->Attributes->DocumentDescription->Authors->AuthorName[0]->Surname." OtherNames=".
		$fullReport->GetReportViewResult->Attributes->DocumentDescription->Authors->AuthorName[0]->OtherNames." CustomID=".
		$fullReport->GetReportViewResult->Attributes->DocumentDescription->Authors->AuthorName[0]->PersonIDs->CustomID);	
}

// Перебор всех полученных отчетов
function enumerate_reports() {
    global $client;
    global $ANTIPLAGIAT_URI;

    echo("Enumerate Reports\n");
    // Выбрать документы пользователя с идентификатором во внешней системе "ivanov"
    $opts = array("ExternalUserID" => 'ivanov', "Count" => 10, "Skip" => 0);
    // Получить первую пачку отчетов, сортировка всегда обратная хронологическая, отчет последнего загруженного документа будет первым
    $reps = $client->EnumerateReportInfos(array("options" => $opts));
    // Счетчик отчетов
    $i = 0;
    // Функция EnumerateReportInfos возвращает результаты проверки пачками. Пустая пачка означает, что перебор завершился.
    while (isset($reps->EnumerateReportInfosResult)) {
        $reps = $reps->EnumerateReportInfosResult;
        foreach ($reps as $info) {
            $i++;
            // Выводим номер по порядку, название документа и статус последнего отчета
            printf("%d  DocName: %s\n   Status: %s\n", $i, $info->DocumentInfo->Attributes->Name, $info->CheckStatus->Status);
            // Если проверка завершена, то выводим процет неоригинальности и ссылку на отчет.
            if ($info->CheckStatus->Status === 'Ready') {
                printf("   %s, %s\n", 100 - $info->CheckStatus->Summary->DetailedScore->Unknown, $ANTIPLAGIAT_URI.$info->CheckStatus->Summary->ReportWebId);
            }
        }
        // Получить следующую пачку отчетов
        $opts["Skip"] = $i;
        $reps = $client->EnumerateReportInfos(array("options" => $opts));
    }
}

// Перебор всех загруженных документов
function enumerate_documents() {
    global $client;

    echo("Enumerate Documents\n");

    // Получить первую пачку документов
    $docs = $client->EnumerateDocuments();

    // Счетчик документов
    $i = 0;
    // Функция EnumerateDocuments возвращает идентификаторы пачками. Пустая пачка означает, что перебор завершился.
    while (isset($docs->EnumerateDocumentsResult)) {
        $docs = $docs->EnumerateDocumentsResult;
        foreach($docs as $id) {
            $i++;
            if ($i % 5 === 0)
                $client->SetIndexState(array("docId" => $id, "indexState" => 'Indexed'));
            // Каждому третьему добавляем атрибут
            if ($i % 3 === 0) {
                $client->UpdateDocumentAttributes(array("docId"=>$id, "attributes"=>array("Custom"=>array("AttrName"=>"docnum", "AttrValue"=>$i.""))));
            }
        }
        $docs = $client->EnumerateDocuments(array("afterDocId" => end($docs)));
    }
    echo("Total documents count: $i (".$client->GetCompanyStats()->GetCompanyStatsResult->TotalCount.")");
}

// Перебор всех документов добавленных в индекс
function enumerate_index() {
    global $client;

    echo("EnumerateIndex\n");
    // При вызове EnumerateDocuments в опциях указывается, что требуются только документы добавленные в индекс
    $docs = $client->EnumerateDocuments(array("options" => array("AddedToIndex" => true)))->EnumerateDocumentsResult;
    // Счетчик документов
    $i = 0;
    // Функция EnumerateDocuments возвращает идентификаторы пачками. Пустая пачка означает, что перебор завершился.
    while (count($docs) > 0) {
        foreach($docs as $id) {
            $i++;
            // Каждый второй документ удаляем из индекса
            if ($i % 2 === 0)
                $client->SetIndexState(array("docId" => $id, "indexState" => 'None'));
        }
        // Получить следующую пачку идентификаторов документов
        $docs = $client->EnumerateDocuments(array("afterDocId"=> end($docs), "options" => array("AddedToIndex" => true)))->EnumerateDocumentsResult;
    }
    echo("Total indexed documents count: $i (".$client->GetCompanyStats()->GetCompanyStatsResult->AddedToIndexCount.")\n");
}

// Проверить документ, получить ссылку на отчет на сайте "Antiplagiat"
function get_web_report($filepath) {
    global $client;
    global $COMPANY_NAME;
    global $ANTIPLAGIAT_URI;
    // Описание загружаемого файла
    $data = get_doc_data($filepath);
    // Загрузка файла
    $uploadResult = $client->UploadDocument(array("data"=>$data));

    // Идентификатор документа. Если загружается не архив, то список загруженных документов будет состоять из одного элемента.
    $id = $uploadResult->UploadDocumentResult->Uploaded[0]->Id;

    // Отправить на проверку с использованием всех подключеных компании модулей поиска
    $client->CheckDocument(array("docId" => $id));
	// Отправить на проверку с использованием только собственного модуля поиска и модуля поиска "wikipedia". Для получения списка модулей поиска см. пример get_tariff_info()
    // $client->CheckDocument(array("docId" => $id, "checkServicesList" => array($COMPANY_NAME, "wikipedia")));

    // Получить текущий статус последней проверки
    $status = $client->GetCheckStatus(array("docId" => $id));

    // Цикл ожидания окончания проверки
    while ($status->GetCheckStatusResult->Status === "InProgress")
    {
        sleep($status->GetCheckStatusResult->EstimatedWaitTime * 0.1);
        $status = $client->GetCheckStatus(array("docId" => $id));
    }

    // Проверка закончилась не удачно.
    if ($status->GetCheckStatusResult->Status === "Failed")
    {
        echo("При проверке документа произошла ошибка:" + $status->GetCheckStatusResult->FailDetails);
        return;
    }

    echo("Full Report: $ANTIPLAGIAT_URI".$status->GetCheckStatusResult->Summary->ReportWebId."\n");
    echo("Short Report: $ANTIPLAGIAT_URI".$status->GetCheckStatusResult->Summary->ShortReportWebId."\n");
    echo("Readonly Report: $ANTIPLAGIAT_URI".$status->GetCheckStatusResult->Summary->ReadonlyReportWebId."\n");
}

# Методы для работы с папками
function folders_methods($filepath1, $filepath2) {
    global $client;

    echo("FoldersMethods\n");

    $email = "testapi@antiplagiat.ru";

    // Пользователь создаёт папку "New Folder"
    $folderId = $client->AddFolder(array("email" => $email, "name" => "New Folder"))->AddFolderResult;

    // Пользователь переименовывает её в "Documents"
    $client->RenameFolder(array("email" => $email, "folderId" => $folderId, "name" => "Documents"));

    // Описание параметров добавления папки
    $folderOptions = array("ParentId" => $folderId);

    // Пользователь создаёт в папке "Documents" новую папку "Important"
    $importantFolderId = $client->AddFolder(array("email" => $email, "name" => "Important", "options" => $folderOptions))->AddFolderResult;

    // Описание первого загружаемого файла
    $data1 = get_doc_data($filepath1);

    // Описание параметров загрузки второго загружаемого файла
    $uploadOptions1 = array("FolderId" => $folderId, "FromUser" => $email);

    // Пользователь загружает в папку "Documents" файл tt1.txt
    $client->UploadDocument(array("data" => $data1, "options" => $uploadOptions1));

    // Описание второго загружаемого файла
    $data2 = get_doc_data($filepath2);

    // Описание параметров загрузки второго загружаемого файла
    $uploadOptions2 = array("FolderId" => $importantFolderId, "FromUser" => $email);

    // Пользователь загружает в папку "Important" файл tt2.txt
    $client->UploadDocument(array("data" => $data2, "options" => $uploadOptions2));

    // Пользователь создаёт папку "Trash"
    $trashFolderId = $client->AddFolder(array("email" => $email, "name" => "Trash"))->AddFolderResult;

    // Описание параметров перечисления документов
    $enumerateDocumentsOptions1 = array("FromUser" => $email);

    // Пользователь получает идентификаторы всех своих документов
    $docs = $client->EnumerateDocuments(array("options" => $enumerateDocumentsOptions1))->EnumerateDocumentsResult;

    // Пользователь перемещает свои документы в папку "Trash"
    $client->MoveDocuments(array("email" => $email, "folderId" => $trashFolderId, "docIds" => $docs));

    // Пользователь получает дерево папок
    $folderTree = $client->GetFolders(array("email" => $email))->GetFoldersResult;

    echo("\nFolderTree:\n");

    echo("\nTop level:\n");
    echo("Name: ");
    echo($folderTree->Name);

    echo("\n\nNext level:\n");

    foreach($folderTree->Children as $folder)
    {
        foreach($folder as $item)
        {
            echo("Name: ");
            echo($item->Name);
            echo("\n");
        }
    }

    echo("\nGet documents from \"Trash\"");

    // Описание параметров перечисления документов
    $enumerateDocumentsOptions2 = array("InStorage" => false, "FolderId" => $trashFolderId, "FromUser" => $email);

    // Пользователь получает свои документы из папки "Trash"
    $trashDocs = $client->EnumerateDocuments(array("options" => $enumerateDocumentsOptions2))->EnumerateDocumentsResult;

    echo("\nDocuments count: ");
    echo(count($trashDocs));
    echo("\n");

    // Пользователь удаляет папки "Documents" и "Trash"
    $client->DeleteFolder(array("email" => $email, "folderId" => $folderId));
    $client->DeleteFolder(array("email" => $email, "folderId" => $trashFolderId));
}

// Методы для работы с хранилищем
function storage_methods($filepath1, $filepath2) {
    global $client;

    echo("StorageMethods\n");

    // Пользователь создаёт папку "New Folder" в хранилище
    $folderId = $client->AddFolder(array("name" => "New Folder"))->AddFolderResult;

    // Пользователь переименовывает её в "Documents"
    $client->RenameFolder(array("folderId" => $folderId, "name" => "Documents"));

    // Описание параметров добавления папки
    $folderOptions = array("ParentId" => $folderId);

    // Пользователь создаёт в папке "Documents" новую папку "Important"
    $importantFolderId = $client->AddFolder(array("name" => "Important", "options" => $folderOptions))->AddFolderResult;

    // Описание первого загружаемого файла
    $data1 = array("Data" => file_get_contents($filepath1),
                  "FileName" => basename($filepath1),
                  "FileType" => "." . substr(strrchr($filepath1, "."), 1));

    // Описание параметров загрузки второго загружаемого файла
    $uploadOptions1 = array("FolderId" => $folderId, "ToStorage" => true);

    // Пользователь загружает в папку "Documents" файл tt1.txt
    $client->UploadDocument(array("data" => $data1, "options" => $uploadOptions1));

    // Описание второго загружаемого файла
    $data2 = array("Data" => file_get_contents($filepath2),
                  "FileName" => basename($filepath2),
                  "FileType" => "." . substr(strrchr($filepath2, "."), 1));

    // Описание параметров загрузки второго загружаемого файла
    $uploadOptions2 = array("FolderId" => $importantFolderId, "ToStorage" => true);

    // Пользователь загружает в папку "Important" файл tt2.txt
    $client->UploadDocument(array("data" => $data2, "options" => $uploadOptions2));

    // Пользователь создаёт папку "Trash" в хранилище
    $trashFolderId = $client->AddFolder(array("name" => "Trash"))->AddFolderResult;

    // Пользователь получает идентификаторы всех документов из хранилища
    $docs = $client->EnumerateDocuments(array("options" => array("InStorage" => true)))->EnumerateDocumentsResult;

    // Пользователь перемещает свои документы в папку "Trash"
    $client->MoveDocuments(array("folderId" => $trashFolderId, "docIds" => $docs));

    // Пользователь получает дерево папок хранилища
    $folderTree = $client->GetFolders(null)->GetFoldersResult;

    echo("\nFolderTree:\n");

    echo("\nTop level:\n");
    echo("Name: ");
    echo($folderTree->Name);

    echo("\n\nNext level:\n");

    foreach($folderTree->Children as $folder)
    {
        foreach($folder as $item)
        {
            echo("Name: ");
            echo($item->Name);
            echo("\n");
        }
    }

    echo("\nGet documents from \"Trash\"");

    // Описание параметров перечисления документов
    $enumerateDocumentsOptions = array("InStorage" => true, "FolderId" => $trashFolderId);

    // Пользователь получает документы хранилища из папки "Trash"
    $trashDocs = $client->EnumerateDocuments(array("options" => $enumerateDocumentsOptions))->EnumerateDocumentsResult;

    echo("\nDocuments count: ");
    echo(count($trashDocs));
    echo("\n");

    // Пользователь удаляет папки "Documents" и "Trash"
    $client->DeleteFolder(array("folderId" => $folderId));
    $client->DeleteFolder(array("folderId" => $trashFolderId));
}

// Получение информации о текущем тарифе
function get_tariff_info() {
  global $client;

  echo("GetTariffInfo\n");

  // Получить информацию о текущем тарифе
  $tariffInfo = $client->GetTariffInfo()->GetTariffInfoResult;

    echo("Tariff name: ");
    echo($tariffInfo->Name);
    echo("\n");

    echo("Tariff subscription date: ");
    echo($tariffInfo->SubscriptionDate);
    echo("\n");

    echo("Tariff expiration date: ");
    echo($tariffInfo->ExpirationDate);
    echo("\n");

    echo("Tariff total checks count: ");
    echo($tariffInfo->TotalChecksCount);
    echo("\n");

    echo("Tariff remained checks count: ");
    echo($tariffInfo->RemainedChecksCount);
    echo("\n");

    echo("\nAvailable check services:");

    foreach($tariffInfo->CheckServices as $checkServices)
    {
        foreach($checkServices as $checkService)
        {
            echo("\n");
            echo($checkService->Code);
            echo("\t");
            echo($checkService->Description);
        }
    }
}

// Проверить документ, получить ссылку на pdf-версию отчета на сайте "Antiplagiat"
function export_report_to_pdf($filepath){
	global $client;
    global $COMPANY_NAME;
	global $ANTIPLAGIAT_URI;
    // Описание загружаемого файла
    $data = get_doc_data($filepath);

	// Загрузка файла
    $uploadResult = $client->UploadDocument(array("data"=>$data));

	// Идентификатор документа.  Если загружается не архив, то список загруженных документов будет состоять из одного элемента.
	$id = $uploadResult->UploadDocumentResult->Uploaded[0]->Id;

	// Отправить на проверку с использованием всех подключеных компании модулей поиска
    $client->CheckDocument(array("docId" => $id));
	// Отправить на проверку с использованием только собственного модуля поиска и модуля поиска "wikipedia". Для получения списка модулей поиска см. пример get_tariff_info()
    // $client->CheckDocument(array("docId" => $id, "checkServicesList" => array($COMPANY_NAME, "wikipedia")));

	// Получить текущий статус последней проверки
    $status = $client->GetCheckStatus(array("docId" => $id));

    // Цикл ожидания окончания проверки
    while ($status->GetCheckStatusResult->Status === "InProgress")
    {
        sleep(max($status->GetCheckStatusResult->EstimatedWaitTime, 10) * 0.1);
        $status = $client->GetCheckStatus(array("docId" => $id));
    }

	// Проверка закончилась не удачно.
    if ($status->GetCheckStatusResult->Status === "Failed")
    {
        echo("При проверке документа произошла ошибка:" + $status->GetCheckStatusResult->FailDetails);
        return;
    }

    // Запросить формирование последнего полного отчета в формат PDF.
    $exportReportInfo = $client->ExportReportToPdf(array("docId" => $id));

    // Цикл ожидания формирования отчета
    while ($exportReportInfo->ExportReportToPdfResult->Status === "InProgress")
    {
        sleep(max($exportReportInfo->ExportReportToPdfResult->EstimatedWaitTime, 10) * 0.1);
        $exportReportInfo = $client->ExportReportToPdf(array("docId" => $id));
    }

    // Формирование отчета закончилось неудачно.
    if ($exportReportInfo->ExportReportToPdfResult->Status === "Failed")
    {
        echo("При формировании отчета произошла ошибка:" + $exportReportInfo->ExportReportToPdfResult->FailDetails);
        return;
    }

	// Получить ссылку на отчет на сайте "Антиплагиат"
    // ВНИМАНИЕ! Не гарантируется что данная ссылка будет работать вечно, она может перестать работать в любой момент,
    // поэтому нельзя давать ее пользвателю. Нужно скачивать pdf себе и дальше уже управлять его временем жизни
    $downloadLink =  join("", array($ANTIPLAGIAT_URI, $exportReportInfo->ExportReportToPdfResult->DownloadLink));
	echo("PDF full report (number = " + $exportReportInfo->ExportReportToPdfResult->ReportNum + "):" + $downloadLink);

	$options = array("ReportNum" => 1,
	                 "ShortReport" => true);

    // Запросить формирование отчета в формат PDF с указанными опциями.
    $exportReportInfo = $client->ExportReportToPdf(array("docId" => $id, "options" => $options));

	// Цикл ожидания формирования отчета
    while ($exportReportInfo->ExportReportToPdfResult->Status === "InProgress")
    {
        sleep(max($exportReportInfo->ExportReportToPdfResult->EstimatedWaitTime, 10) * 0.1);
        $exportReportInfo = $client->ExportReportToPdf(array("docId" => $id, "options" => $options));
    }

	// Формирование отчета закончилось неудачно.
    if ($exportReportInfo->ExportReportToPdfResult->Status === "Failed")
    {
        echo("При формировании отчета произошла ошибка:" + $exportReportInfo->ExportReportToPdfResult->FailDetails);
        return;
    }

	// Получить ссылку на отчет на сайте "Антиплагиат"
    // ВНИМАНИЕ! Не гарантируется что данная ссылка будет работать вечно, она может перестать работать в любой момент,
    // поэтому нельзя давать ее пользвателю. Нужно скачивать pdf себе и дальше уже управлять его временем жизни
    $downloadLink =  join("", array($ANTIPLAGIAT_URI, $exportReportInfo->ExportReportToPdfResult->DownloadLink));
	echo("PDF full report (number = " + $exportReportInfo->ExportReportToPdfResult->ReportNum + "):" + $downloadLink);
}

// Пример получения справки по проверенному файлу
function get_verification_report($filepath)
{
    global $client;

    // Описание загружаемого файла
    $data = get_doc_data($filepath);
    // Загрузка файла
    $uploadResult = $client->UploadDocument(array("data"=>$data));

    // Идентификатор документа. Если загружается не архив, то список загруженных документов будет состоять из одного элемента.
    $id = $uploadResult->UploadDocumentResult->Uploaded[0]->Id;

    // Отправить на проверку с использованием всех подключеных компании модулей поиска
    $client->CheckDocument(array("docId" => $id));
	// Отправить на проверку с использованием только собственного модуля поиска и модуля поиска "wikipedia". Для получения списка модулей поиска см. пример get_tariff_info()
    // $client->CheckDocument(array("docId" => $id, "checkServicesList" => array($COMPANY_NAME, "wikipedia")));

    // Получить текущий статус последней проверки
    $status = $client->GetCheckStatus(array("docId" => $id));

    // Цикл ожидания окончания проверки
    while ($status->GetCheckStatusResult->Status === "InProgress")
    {
        sleep($status->GetCheckStatusResult->EstimatedWaitTime * 0.1);
        $status = $client->GetCheckStatus(array("docId" => $id));
    }

    // Проверка закончилась не удачно.
    if ($status->GetCheckStatusResult->Status === "Failed")
    {
        echo("При проверке документа произошла ошибка:" + $status->GetCheckStatusResult->FailDetails);
        return;
    }

    //Выгрузить справку можно c заполненными полями или без
    //Без заполненных полей
    //$report = $client->GetVerificationReport(array("docId" => $id));

    //Для заполнения полей необходимо создать объект опций справки с желаемыми значениями свойств
    $options = array("Author" 		=> "Иванов И.И.", // ФИО автора работы
    "Department" 	=> "Факультет общей и прикладной физики", // Факультет (структурное подразделение)
    "ShortReport" 	=> true, //  Требуется ли ссылка на краткий отчёт? (qr код)
    "Type" 			=> "Дипломная работа", // Тип работы
    "Verifier" 		=> "Петров П.П.", // ФИО проверяющего
    "Work" 			=> "Когерентная спиновая динамика двумерного электронного газа"  // Название работы
    );

    $verRepFileName = get_ver_rep_filename($id, $options);

    //С заполнением полей
    $report = $client->GetVerificationReport(array("docId" => $id, "options" => $options));

    //запись в файл
    $objData = serialize( $report);
    $savePath = $verRepFileName;
        $fp = fopen($savePath, "w");
        fwrite($fp, $objData);
        fclose($fp);
}

//пример получения библиографии по файлу
function get_bibliography($filepath) {
    global $client;
	
    // Описание загружаемого файла
    $data = get_doc_data($filepath);
    // Загрузка файла
    $uploadResult = $client->UploadDocument(array("data" => $data));

    // Идентификатор документа. Если загружается не архив, то список загруженных документов будет состоять из одного элемента.
    $id = $uploadResult->UploadDocumentResult->Uploaded[0]->Id;
	
    $status = $client->GetTextExtractStatus(array("docId" => $id));

    // Цикл ожидания окончания проверки 
    while ($status->GetTextExtractStatusResult->TextStatus === "InProgress")
    {
        sleep(1);
        $status = $client->GetTextExtractStatus(array("docId" => $id));
    }
	
    // Загрузка закончилась не удачно.
    if ($status->GetTextExtractStatusResult->TextStatus === "Failed")
    {
        echo("При загрузке документа произошла ошибка" );
        return;
    }
	
	$result = $client->GetBibliographyText(array("docId" => $id))->GetBibliographyTextResult;
    if ($result->Status !== "Ok")
    {
        echo("Библиография не извлечена" );
        return;
    }
	foreach ($result->MarkedText as $texts)
	{
        foreach($texts as $text)
        {
			echo($text);
		}
	}    
}

function selfcite_check($filepath) {
    global $client;
    global $COMPANY_NAME;
    // Описание загружаемого файла
    $data = get_doc_data($filepath);
	$attributes = array(
		"DocumentDescription" => array(
			"Authors" => array (
				"AuthorName" => array (
					"OtherNames" => "Иван Иванович",
					"Surname" => "Иванов",
					"PersonIDs" => array(
						"CustomID" => "original"
					)
				)

			)
		)
	);
	$opts = array(
		"AddToIndex" => true
	);
    // Загрузка файла
    $uploadResult = $client->UploadDocument(array("data"=>$data, "attributes"=>$attributes, "options"=>$opts));

    // Идентификатор документа. Если загружается не архив, то список загруженных документов будет состоять из одного элемента.
    $id = $uploadResult->UploadDocumentResult->Uploaded[0]->Id;

	// Отправить на проверку с использованием всех подключеных компании модулей поиска
    $client->CheckDocument(array("docId" => $id));

    // Получить текущий статус последней проверки
    $status = $client->GetCheckStatus(array("docId" => $id));

    // Цикл ожидания окончания проверки
    while ($status->GetCheckStatusResult->Status === "InProgress")
    {
        sleep($status->GetCheckStatusResult->EstimatedWaitTime * 0.1);
        $status = $client->GetCheckStatus(array("docId" => $id));
    }

    // Проверка закончилась не удачно.
    if ($status->GetCheckStatusResult->Status === "Failed")
    {
        echo("При проверке документа произошла ошибка:" + $status->GetCheckStatusResult->FailDetails);
        return;
    }
	
    $uploadResult = $client->UploadDocument(array("data"=>$data, "attributes"=>$attributes));
    $idSelfCite = $uploadResult->UploadDocumentResult->Uploaded[0]->Id;
	
    $client->CheckDocument(array("docId" => $idSelfCite));

    // Получить текущий статус последней проверки
    $status = $client->GetCheckStatus(array("docId" => $idSelfCite));

    // Цикл ожидания окончания проверки
    while ($status->GetCheckStatusResult->Status === "InProgress")
    {
        sleep($status->GetCheckStatusResult->EstimatedWaitTime * 0.1);
        $status = $client->GetCheckStatus(array("docId" => $idSelfCite));
    }

    // Получить краткий отчет
    $report = $client->GetReportView(array("docId" => $idSelfCite));
	#Должно быть полное самоцитирование
    echo("Report SelfCite:" . $report->GetReportViewResult->Summary->DetailedScore->SelfCite);

}


function get_ver_rep_filename($id, $reportOptions)
{
    $author = '';

    if (!is_null($reportOptions))
        if (!IsNullOrEmptyString($reportOptions['Author']))
            $author = '_' . $reportOptions['Author'];

    $curDate = date("Ymd");

    return sprintf("Certificate_%s_%s%s.pdf", $id->Id, $curDate, $author);
}

function IsNullOrEmptyString($str){
    return (!isset($str) || trim($str) === '');
}

// soap_debug($client);
try {
    // simple_check("test_wiki.pdf");
    // enumerate_documents();
    // enumerate_index();
    // get_web_report("test_wiki.pdf");
    // folders_methods("test_wiki.pdf", "test_wiki.pdf");
    // storage_methods("test_wiki.pdf", "test_wiki.pdf");
    // export_report_to_pdf("test_wiki.pdf");
    // get_tariff_info();
    // get_verification_report("test_wiki.pdf");
     enumerate_reports();
    // get_bibliography("test.txt");
    // selfcite_check("test_wiki.pdf");
	
} catch (SoapFault $e) {
    var_dump($e->getCode());
    var_dump($e);
    soapDebug($client);
}

?>